#ifndef __COMMON_H
#define __COMMON_H

#ifndef __KERNEL__              // only for user space applications
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>

#define ERR(...)  fflush( stdout ), fprintf( stderr, __VA_ARGS__ ), fflush( stderr ), exit( EXIT_FAILURE )

#else                           // for kernel space module
#include <linux/module.h>
#include <linux/version.h>
#include <linux/init.h>
#include <linux/kallsyms.h>
#include <linux/uaccess.h>
#include <linux/unistd.h>
#include <linux/miscdevice.h>
#include <linux/inet.h>
#include <linux/netdevice.h>
#include <linux/mutex.h>

#define PREFIX "! "
#define DEB(...) if( debug ) printk( KERN_INFO PREFIX __VA_ARGS__ )
#define LOG(...) printk( KERN_INFO PREFIX __VA_ARGS__ )
#define ERR(...) printk( KERN_ERR PREFIX __VA_ARGS__ )

static bool debug = false;      // logical parameter: debug output level, 0/1
module_param( debug, bool, 0 );

#endif // __KERNEL__

#define DEVNAME "policy"        // device file name in /dev
#define LEN_MSG 256             // text messages max length

#endif // __COMMON_H
