#include "../common.h"

int main( int argc, char *argv[] ) {
   char dev[ 80 ] = "/dev/", c, sopt[] = "v";
   int df, debug_level = 0;
   while( -1 != ( c = getopt( argc, argv, sopt ) ) )
      switch( c ) {
         case 'v':
            debug_level++;
            break;
         default :
            fprintf( stderr, "use: %s [-v[v...]]\n", argv[ 0 ] );
            exit( EXIT_FAILURE );
      }
   strcat( dev, DEVNAME );
   if( ( df = open( dev, O_RDWR ) ) < 0 )
      printf( "open device %s error: %m\n", dev ), exit( EXIT_FAILURE );
   char msg[ LEN_MSG ];
   int res;
   do {
      res = read( df, msg, sizeof( msg - 1 ) );
      if( res < 0 ) {
         fprintf( stderr, "read device error: %m\n" );
         break;
      }
      msg[ res ] = '\0';
      fprintf( stdout, "read %d bytes: %s\n", res, msg );
      msg[ 0 ] = 1;
      res = write( df, msg, 1 );
      if( res < 0 ) {
         fprintf( stderr, "write device error: %m\n" );
         break;
      }
      fprintf( stdout, "write %d byte\n", res );
   } while ( res > 0 );
   close( df );
   return EXIT_SUCCESS;
};
